//+------------------------------------------------------------------+
//|                                             stochastic meter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 0

//
//
//
//
//

extern string StoTimeFrames        = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern int    StoKPeriod           = 14;
extern int    StoSlowingPeriod     =  3;
extern int    StoPrice             =  0;
extern int    IndicatorMagicNumber =  1;
extern int    IndicatorWindow      =  0;
extern int    IndicatorCorner      =  3;
extern int    IndicatorXPosition   = 10;
extern int    IndicatorYPosition   = 10;
extern int    IndicatorSteps       = 15;
extern bool   IndicatorMiddleLine  = true;
extern color  IndicatorTextColor   = LightGray;
extern color  IndicatorBackColor   = DimGray;
extern color  IndicatorStartColor  = OrangeRed;
extern color  IndicatorEndColor    = LimeGreen;

//
//
//
//
//

string  identifierName;
string  labels[];
int     periods[];
int     middle;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorCorner = MathMax(MathMin(IndicatorCorner, 3), 0);
   IndicatorSteps  = MathMax(MathMin(IndicatorSteps ,75),15);
   if (IndicatorMiddleLine)
      if (MathMod(IndicatorSteps,2)==0) IndicatorSteps++;
                               middle = IndicatorSteps/2;

   //
   //
   //
   //
   //
      
   StoTimeFrames = StringTrimLeft(StringTrimRight(StringUpperCase(StoTimeFrames)));
   if (StringSubstr(StoTimeFrames,StringLen(StoTimeFrames),1) != ";")
                    StoTimeFrames = StringConcatenate(StoTimeFrames,";");

   //
   //
   //
   //
   //                                   
            
   int s = 0;
   int i = StringFind(StoTimeFrames,";",s);
   while (i > 0)
   {
      string current = StringSubstr(StoTimeFrames,s,i-s);
      int    time    = stringToTimeFrame(current);
         if (time > 0) {
            ArrayResize(labels ,ArraySize(labels)+1);
            ArrayResize(periods,ArraySize(periods)+1);
                        labels[ArraySize(labels)-1] = timeFrameToString(time); 
                        periods[ArraySize(periods)-1] = time; }
                        s = i + 1;
                            i = StringFind(StoTimeFrames,";",s);
   }
   identifierName = "stometer"+IndicatorMagicNumber+":";
}

//
//
//
//
//

int deinit()
{
   int identifierLength = StringLen(identifierName);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name,0,identifierLength) == identifierName)
                                       ObjectDelete(name);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define distance 43

int start()
{
   int totalTimeFrames=ArraySize(periods);
   
   //
   //
   //
   //
   //
   
   int xPosition = IndicatorXPosition+10;
   int angle     = 90;
   int displ     = 1;
         
         if (IndicatorCorner==0 || IndicatorCorner==3) angle = 270;
         if (IndicatorCorner==0 || IndicatorCorner==2) displ =   0;
               setElement("0+0",xPosition      ,IndicatorYPosition,IndicatorBackColor,"gggggggg","Webdings",10,angle);
               setElement("0+1",xPosition+displ,IndicatorYPosition,IndicatorTextColor,"   Stochastic "+StoKPeriod+","+StoSlowingPeriod+"  ","Arial"   , 9,angle);
               xPosition++;
   
   //
   //
   //
   //
   //

   for (int t=0; t<totalTimeFrames; t++)
   {
      string label = labels[t];
      int    time  = periods[t];

      if (IndicatorCorner==1 || IndicatorCorner==3)
      {
         label = labels[totalTimeFrames-t-1];
         time  = periods[totalTimeFrames-t-1];
      }
         
      //
      //
      //
      //
      //
       
      double sto = iStochastic(NULL,time,StoKPeriod,1,StoSlowingPeriod,MODE_SMA,StoPrice,MODE_MAIN,0);
      for (int i=0; i<IndicatorSteps; i++)
      {
         int    pos = i; if (IndicatorCorner==0 || IndicatorCorner==1) pos = IndicatorSteps-i-1;
         double value = (i+1)*100.0/(IndicatorSteps+1);
         
         //
         //
         //
         //
         //
         
         if (IndicatorMiddleLine)
         {
            if (i==middle)
            {
                setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
                continue; 
            }                
            if (sto>50)
            {
               if (i<middle) { setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor); continue; }
               if (sto>=value)
                     setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       
            }
            else
            {
               if (i>middle) { setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor); continue; }
               if (sto<=value)
                     setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
               else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       
            }
            continue;            
         }

         //
         //
         //
         //
         //
               
         if (sto>value)
               setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,gradientColor(i,IndicatorSteps,IndicatorStartColor,IndicatorEndColor));
         else  setElement(t+"-"+i,xPosition+t*distance,IndicatorYPosition+pos*7,IndicatorBackColor);       

         //
         //
         //
         //
         //

      }         
      setElement(t+"-"+i,xPosition+t*distance+10,IndicatorYPosition+i*7,IndicatorTextColor,label,"arial",10);
   }
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void setElement(string element, int x, int y, color ecolor=Silver, string text = "ggggggg", string fontname="Webdings", int fontsize = 5.5, int angle=0)
{
   string name = identifierName+element;
   ObjectCreate(name, OBJ_LABEL, IndicatorWindow, 0, 0);
      ObjectSet(name, OBJPROP_XDISTANCE, x);
      ObjectSet(name, OBJPROP_YDISTANCE, y);
      ObjectSet(name, OBJPROP_BACK, FALSE);
      ObjectSet(name, OBJPROP_CORNER, IndicatorCorner);
      ObjectSet(name, OBJPROP_ANGLE, angle);
      ObjectSetText(name, text, fontsize, fontname, ecolor);
}

//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(0);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}